clear, clc, mode(0), close(winsid()) 

////Odhad a vícekroková predikce s diskrétním modelem $f(y_t|y_{t-1},u_t,\Theta)$
///$y_t\in\{0,1,2\}$ -- dopravní prostředek (tramvaj, autobus, auto)
////$u_t\in\{1,2,3,4,5,6,7\}$ -- den v týdnu

load data9_priklad1.sod;

nd=size(u,2);
np=5;


min(y)
max(y)

//scf(1);
//plot(y,'.');
//title('Původní data - hodnoty 0,1,2','fontsize',5);
//ylabel('Výstup','fontsize',5);
//xlabel('Čas','fontsize',5);
//set(gca(),"data_bounds",[0 nd -1 3.1]);



//////zpracování dat 
y=y+ones(nd,1);

//scf(2);
//plot(y,'g.');
//title('Zpracovaná data - hodnoty 1,2,3','fontsize',5);
//ylabel('Výstup','fontsize',5);
//xlabel('Čas','fontsize',5);
//set(gca(),"data_bounds",[0 nd -1 3.1]);



min(u)
max(u)
//scf(3);
//plot(u,'m.');
//title('Řídící vstup','fontsize',5);
//ylabel('Vstup','fontsize',5);
//xlabel('Čas','fontsize',5);



/// Odhad
///////// Počáteční statistika
ni=zeros(max(u)*max(y),max(y)); //dimenze podle modelu


ni1=ni(1:7,:); ni2=ni(8:14,:); ni3=ni(15:21,:);// 7 řádků pro každý u(t)


for t=2:nd
    if y(t-1)==1 then
        ni1(u(t),y(t))=ni1(u(t),y(t))+1; // update statistiky
    elseif y(t-1)==2 then
        ni2(u(t),y(t))=ni2(u(t),y(t))+1; // update statistiky
    else 
        ni3(u(t),y(t))=ni3(u(t),y(t))+1; // update statistiky
    end   
end

ni=[ni1;ni2;ni3]; // celá statistika po updatu

theta_odhad=ni./(sum(ni,2)*ones(1,3));  //bodový odhad parametrů




/////////více-kroková predikce
for t=2:(nd-np)
    yy(t-1)=y(t-1);    //uložíme stará data
    for i=0:np   
        if yy(t+i-1)==1 then
            p=theta_odhad(1:7,:); // 7 řádků pro každý u(t)
        elseif yy(t+i-1)==2 then
            p=theta_odhad(8:14,:);
        else p=theta_odhad(15:21,:);
        end
        pp=cumsum(p(u(t+i),:));
        yy(t+i)=sum(rand(1,1,'uniform')>pp)+1;//generujeme predikci 
    end
    yp(t+np)=yy(t+np);  //uložíme vice-krokovou predikci
end



///Výsledky
//Chyba predikce
//Chyba predikce
PE=sum(y~=yp); 
Acc=(PE*100)/length(yp);
disp('Chyba predikce: '+string(Acc)+'%')



scf(4);
plot(y,'bs');
plot(yp,'r.');
set(gca(),"data_bounds",[0 nd .9 3.1]);
legend('data','predikce',-1);
title('Vícekroková předpověď','fontsize',5);
ylabel('Výstup','fontsize',5);
xlabel('Čas','fontsize',5);

